unit EngineUtils;

interface

uses eXgine, SysUtils, Windows, Messages, Consts;

type TRect = record
     x,y,w,h: integer;
     end;

var TextFlag   : boolean = true;
    DeleteFlag : boolean = true;
    KeyAr:   Array[0..256] of boolean;//  
    AnyKey:  integer = 0;             //-   
    FlagResetKey:     integer = 0;    //     


function ReturnRect(x,y,w,h: integer): TRect;
function PointInRect(x,y: integer; r: TRect): boolean;
function nvl(p,p1: variant): variant;
function ReturnCharFromNumber(i: integer): char;
function getAng(x1, y1, x2, y2: integer): double;
function GLTextUtil(OldText: string; MaxLen: integer) : string;
function GetMouseButtonPressed: integer;
function GetTextWidth(Font: cardinal; txt: string): integer;
function GetTextHeight: integer;
function InKey(Key: integer): boolean;
procedure ResetKey;
function RectInRect(R:TRect;R2:TRect):boolean;

implementation

uses Variants, Math;

function getAng(x1, y1, x2, y2: integer): double;
var
  hyp, kat1, kat2: single;
begin
  result:= 0;
  hyp:= sqrt(sqr(y1 - y2) + sqr(x1 - x2));
  kat1:= x2 - x1;
  kat2:= y1 - y2;
  if kat2 >= 0 then
  begin
    if hyp <> 0 then
      result := radtodeg(arcsin(kat1 / hyp))
  end
  else
  if hyp <> 0 then
    result:= 180 - radtodeg(arcsin(kat1 / hyp));
  if result > 90 then
    result:= result - 90
  else
    result:= 270 + result;
end;

function nvl(p,p1: variant): variant;
begin
  if p = Null then
    Result:= p1
  else
    Result:= p;
end;

function ReturnRect(x,y,w,h: integer): TRect;
begin
  Result.x:= x;
  Result.y:= y;
  Result.w:= w;
  Result.h:= h;
end;

function PointInRect(x,y: integer; r: TRect): boolean;
begin
  if (x >= r.x) and (x <= r.x+r.w) and (y >= r.y) and (y <= r.y+r.h) then
    Result:= True
  else
    Result:= False;
end;

function ReturnCharFromNumber(i: integer): char;
begin
  Result:= chr(i);
end;

function GLTextUtil(OldText: string; MaxLen: integer) : string;
var str_return : string;
    i          : integer;
begin
  str_return:= '';
  if (inp.GetGLKeyboardText in [32..255]) and (inp.GetGLKeyboardText<>0) and (TextFlag = true) and (length(OldText) < MaxLen) then
  begin
    str_return:= chr(inp.GetGLKeyboardText);
    TextFlag:= false;
  end;
  if inp.Down(Key_Backspace) and (DeleteFlag = true) then
  begin
    str_return:= OldText;
    OldText:= '';
    if Length(str_return) > 1 then
    begin
      for i:= 1 to length(str_return)-1 do
      begin
        OldText:= OldText+str_return[i];
      end;
    end;
    str_return:= '';
    DeleteFlag:= false;
  end;
  if inp.GetGLKeyboardText = 0 then
    TextFlag:= true;
  if inp.Down(Key_Backspace) = false then
    DeleteFlag:= true;
  Result:= OldText+str_return;
end;

function GetMouseButtonPressed: integer;
begin
  if (inp.Down(M_BTN_1)) then
    Result:= MB_LEFT
  else if (inp.Down(M_BTN_2)) then
    Result:= MB_RIGHT
  else if (inp.Down(M_BTN_3)) then
    Result:= MB_MIDDLE
  else
    Result:= MB_NONE;
end;

function GetTextWidth(Font: cardinal; txt: string): integer;
begin
  Result:= ogl.textLen(Font,Pchar(txt));
end;

function GetTextHeight: integer;
begin
  Result:= 16;
end;

//------------------------------------------------------------------------------
function InKey(Key: integer): boolean;
var i: integer;
begin
  InKey:= false;
  AnyKey:= 0;
  if (inp.Down(Key) = true) and (KeyAr[Key] = false) then
  begin
    InKey:= true;
    KeyAr[key]:= true;
  end;
  if inp.Down(Key) = false then
    KeyAr[key]:= false;
  for i:= 0 to 256 do
  begin
    if KeyAr[i] = true then
      AnyKey:= AnyKey+1;
  end;
  if AnyKey <> 1 then
    InKey:= false;
  if AnyKey = 0 then
    flagResetKey:= 0;
end;

//------------------------------------------------------------------------------
procedure ResetKey;
var i: integer;
begin
  for i:= 0 to 256 do
    KeyAr[i]:= false;
end;

//-----------    ---------------
function RectInRect(R:TRect;R2:TRect):boolean;
begin
  result:=
    (R.x < R2.X+R2.w) and
    (R.x+R.w > R2.x) and
    (R.y < R2.y+R2.h) and
    (R.y+R.h > R2.y) or
    (R2.x < R.x+R.w) and
    (R2.x+R2.w > R.x) and
    (R2.y < R.y+R.h) and
    (R2.y+R2.h > R.y);
end;


end.
