unit Main;

interface

uses eXgine, SysUtils, Math, MyInterface, EngineUtils, Consts, SpriteEngine, GUI,
     level, redactor, Player, inifiles;

const StatusMenu        = 0;
      StatusGame        = 1;
      StatusSetting     = 2;
      StatusRecord      = 3;
      StatusContinue    = 4;
      StatusRedactor    = 5;
      StatusHelp        = 6;
      CameraSpeed       = 2;
      DefaultStartX     = 32;
      DefaultStartY     = 32;
      leftVector        = -1;
      rigthVector       = 1;
      defaultMusic      = 0;
      defaultSound      = 0;
      defaultFullScreen = 1;
      FileSettingName   = 'setting.ini';

procedure MainProcessBegin;
procedure MainProcessEnd;
procedure MainDraw;
procedure MainInit;
procedure MainFree;
procedure MainProcess;
procedure MainExit;
procedure LogoDraw;
procedure NewGame;
procedure StartGame(lvl: integer; nextRound: boolean);
procedure LevelEnd(endGame: boolean);
procedure SettingLoad;
procedure SettingSave(music, sound, fullscreen: integer);
procedure GameWin;

var MousePosition: TVector2f;
    texFon       : Cardinal;
    ScreenStartX : integer = 50;
    ScreenStartY : integer = 400;
    ScreenW      : integer = 800;
    ScreenH      : integer = 600;
    Status       : integer = 0;// 0- 1- 2- 3- 4- 5- 
    PausePlayer  : boolean;
    PauseGame    : boolean;
    CameraMainX  : integer;
    FlagEndRound : boolean;
    FlagEndGame  : boolean;
    MusicOn      : integer;
    SoundOn      : integer;
    FullScreenOn : integer;
    ScoreWin     : integer;
    texPause     : cardinal;
    texLevelEnd  : cardinal;
    texGameEnd   : cardinal;

implementation

procedure MainExit;
begin
  eX.Quit;
end;

procedure MainProcessBegin;
begin
  {MousePosition.X:= MousePosition.X + inp.MDelta.X;
  MousePosition.Y:= MousePosition.Y + inp.MDelta.Y;
  if MousePosition.X < 0 then MousePosition.X := 0;
  if MousePosition.Y < 0 then MousePosition.Y := 0;
  if MousePosition.X > ScreenW then MousePosition.X := ScreenW;
  if MousePosition.Y > ScreenH then MousePosition.Y := ScreenH;
  CursorX:= round(MousePosition.X);
  CursorY:= round(MousePosition.Y);}
  MainCursorShow:= true;
  CursorX:= inp.GetMouseCoord.X;
  CursorY:= inp.GetMouseCoord.Y;
  MouseWheel:= inp.WDelta;
end;

procedure MainProcess;
begin
  FonProcess;
  if InKey(Key_F12) then
    ogl.ScreenShot('screenshot\scn1.bmp');
  if Status = StatusGame then
  begin
    if MainCursorShow = true then
      MainCursorShow:= false;
  end
  else
  begin
    if MainCursorShow = false then
      MainCursorShow:= true;
  end;
  case Status of
    StatusMenu:begin
                 MyInt.Process;
                 if InKey(Key_F1) then
                   Status:= StatusHelp;
                 if InKey(Key_R) then
                   RedactorStart;
                 if InKey(Key_Escape) then
                   MainExit;
               end;
    StatusGame:begin
                 if (PauseGame = false) and
                    (FlagEndRound = false) and
                    (FlagEndGame = false) then
                 begin
                   Levels[CurrentLevel].Process(1,true,false);
                   if not PausePlayer then
                   begin
                     Players.Process;
                   end;
                   DifferentProcess;
                 end;
                 if FlagEndRound then
                 begin
                   DifferentProcess;
                   if InKey(Key_Enter) then
                     StartGame(CurrentLevel+1,true);
                 end;
                 if FlagEndGame then
                 begin
                   DifferentProcess;
                   if InKey(Key_Enter) then
                     GameWin;
                 end;
                 if InKey(Key_Escape) then
                 begin
                   inp.Reset;
                   if MusicOn = 0 then
                     snd.PlayFile('data\main.mid',true);
                   Status:= StatusMenu;
                 end;
                 if InKey(Key_P) then
                 begin
                   if PauseGame = true then
                     PauseGame:= false
                   else
                     PauseGame:= true;
                 end;
               end;
    StatusSetting:begin
                    SettingProcess;
                    if InKey(Key_Escape) then
                      SettingBtnExit;
                  end;
    StatusRecord:begin
                   RecordProcess;
                   if InKey(Key_Escape) then
                     Status:= StatusMenu;
                 end;
    StatusRedactor:begin
                     RedactorProcess; 
                     if InKey(Key_Escape) then
                       Status:= StatusMenu;
                   end;
    StatusHelp:begin
                 HelpProcess;
               end; 
  end;
  SnowProcess;
end;

procedure MainProcessEnd;
begin
  if AnyKey = 1 then
  begin
    flagResetKey:= flagResetKey+1;
    if flagResetKey > 10 then
    begin
      ResetKey;
      flagResetKey:= 0;
    end;
  end;
  MouseWheel:= 0;
  if (GetMouseButtonPressed = MB_LEFT) or
     (GetMouseButtonPressed = MB_MIDDLE) or
     (GetMouseButtonPressed = MB_RIGHT) or
     (GetMouseButtonPressed = MB_NONE) then
  begin
    MouseDown:= GetMouseButtonPressed;
  end;
end;

procedure MainDraw;
begin
  FonDraw;
  SnowDraw;
  case Status of
    StatusMenu:begin
                 MyInt.Draw;
               end;
    StatusGame:begin
                 Levels[CurrentLevel].Draw;
                 Players.Draw(CameraMainX);
                 DifferentDraw;
                 ScoreDraw;
                 HealthDraw;
                 ReloadDraw;
                 if PauseGame then
                   DrawSprite2D_simple(texPause,(wnd.Width div 2) - 64,
                                       (wnd.Height div 2) - 16, 128, 32);
                 if FlagEndRound then
                   DrawSprite2D_simple(texLevelEnd,(wnd.Width div 2) - 128,
                                       (wnd.Height div 2) - 32, 256, 64);
                 if FlagEndGame then
                   DrawSprite2D_simple(texGameEnd,(wnd.Width div 2) - 128,
                                       (wnd.Height div 2) - 32, 256, 64);
               end;
    StatusSetting:begin
                    SettingDraw;
                  end;
    StatusRecord:begin
                   RecordDraw;
                 end;
    StatusRedactor:begin
                     RedactorDraw;
                   end;
    StatusHelp:begin
                 HelpDraw;
               end;
  end;
  LogoDraw;
  if MainCursorShow then
    DrawSprite2D_simple(MainCursorTex,CursorX,CursorY,MainCursorW,MainCursorH);
end;

procedure MainInit;
begin
  MousePosition.X:= 0;
  MousePosition.Y:= 0;
  flagResetKey:= 0;
  CameraMainX:= 0;
  FlagEndRound:= false;
  FlagEndGame:= false;
  MainCursorTex:= tex.Load('data\MainCursor.tga');
  texPlayer:= tex.load('data\player.tga');
  texPlayerHand:= tex.load('data\playerhand.tga');
  texEffect:= tex.load('data\effect.tga');
  texFon:= tex.load('data\fon.jpg');
  texSnowBall:= tex.load('data\snowball.tga');
  texSnowBallDestroy:= tex.load('data\snowballdestroy.tga');
  texPause:= tex.load('data\pausa.tga');
  texLevelEnd:= tex.load('data\levelend.tga');
  texGameEnd:= tex.load('data\gameend.tga');
  texSnowTime:= tex.load('data\snowtime.tga');
  texNumber:= tex.load('data\number.tga');
  FonInit;
  GUIInit;
  SettingInit;
  RecordLoad;
  LevelTexInit;
  CurrentLevel:= 1;
  Players:= TPlayer.Create;
  Levels[1]:= TLevel.Create;
  Levels[2]:= TLevel.Create;
  Levels[3]:= TLevel.Create;
  Levels[1].Init;
  Levels[2].Init;
  Levels[3].Init;
  SettingLoad;
  Status:= StatusMenu;
  if MusicOn = 0 then
    snd.PlayFile('data\main.mid',true);
end;

procedure MainFree;
begin
  MyInt.Destroy;
  if Level0 <> nil then
    Level0.Destroy;
  Level0:= nil;
end;

procedure LogoDraw;
begin
  //DrawText2D(0,0,wnd.Height-32,' ',$FF0000);
  DrawSprite2D_simple(texLogo,0,wnd.Height-32,128,32);
end;

procedure NewGame;
begin
  StartGame(1,false);
end;

procedure StartGame(lvl: integer; nextRound: boolean);
var numElement: integer;
    tmpX, tmpY: integer;
begin
  FlagEndRound:= false;
  if MusicOn = 0 then
    snd.PlayFile(PChar('data\level'+inttostr(lvl)+'.mid'),true);
  PausePlayer:= true;
  PauseGame:= false;
  Status:= StatusGame;
  CurrentLevel:= lvl;
  LoadLevel(CurrentLevel);
  tmpX:= DefaultStartX;
  tmpY:= DefaultStartY;
  for numElement:= 0 to levels[CurrentLevel].countPlace-1 do
  begin
    if levels[CurrentLevel].Place[numElement].ID = PlaceStart then
    begin
      tmpX:= levels[CurrentLevel].Place[numElement].Rect.x;
      tmpY:= levels[CurrentLevel].Place[numElement].Rect.y;
      break;
    end;
  end;
  EffectCreate(tmpX,tmpY-PlayerH div 2,PlayerW,PlayerH,true);
  CameraMainX:= tmpX - wnd.Width div 2;
  if CameraMainX < 0 then
    CameraMainX:= 0;
  if CameraMainX+wnd.Width > Levels[CurrentLevel].Width then
    CameraMainX:= Levels[CurrentLevel].Width-wnd.Width;
  if nextRound = true then
    Players.Init(tmpX,tmpY-PlayerH div 2,true)
  else
    Players.Init(tmpX,tmpY-PlayerH div 2,false);
end;

procedure LevelEnd(endGame: boolean);
begin
  if endGame = false then
    FlagEndRound:= true
  else
    FlagEndGame:= true;
end;

procedure SettingLoad;
var SettingIni: TIniFile;
begin
  SettingIni:= TIniFile.Create(GetCurrentDir+'\'+FileSettingName);
  MusicOn:= SettingIni.ReadInteger('Setting','MusicOn',defaultMusic);
  SoundOn:= SettingIni.ReadInteger('Setting','SoundOn',defaultSound);
  FullScreenOn:= SettingIni.ReadInteger('Setting','FullScreen',defaultFullScreen);
  SettingIni.Free;
  SetCheckBox[SetBoxMusic].Status:= MusicOn;
  SetCheckBox[SetBoxSound].Status:= SoundOn;
  SetCheckBox[SetBoxScreen].Status:= FullScreenOn;
  if FullScreenOn = 0 then
    wnd.Mode(true, 0, 0, ScreenW, ScreenH, 32, 75);
end;

procedure SettingSave(music, sound, fullscreen: integer);
var SettingIni: TIniFile;
begin
  SettingIni:= TIniFile.Create(GetCurrentDir+'\'+FileSettingName);
  SettingIni.WriteInteger('Setting','MusicOn',music);
  SettingIni.WriteInteger('Setting','SoundOn',sound);
  SettingIni.WriteInteger('Setting','FullScreen',fullscreen);
  SettingIni.Free;
  SoundOn:= sound;
  MusicOn:= music;
  FullScreenOn:= fullscreen;
end;

procedure GameWin;
begin
  FlagEndGame:= false;
  if MusicOn = 0 then
    snd.PlayFile('data\main.mid',true);
  RecordInit(Players.Score);
end;

end.
