unit mutils;
interface
{$Warnings off}
{$Hints on}
uses windows;

type
  TByteArray = array [0..1023] of Byte;
  PByteArray = ^TByteArray;


Function SameText(A,B:String):Boolean;
function FileExists(FileName: string): boolean;
function AnsiUpperCase(const S: string): string;
function LowerCase(const S: string): string;
function CompareMem(P1, P2: Pointer; Length: Integer): Boolean; assembler;
function StrToIntDef(const S: string; Default: Integer): Integer;
function StrToFloatDef(strValue : String; defValue : Single) : Single;
function FloatToStr(Value: Extended): string;
function StrPas(const Str: PChar): string;
function booltostr(B:Boolean):String;
function TrimLeft(const S: string): string;
function ExtractFilePath(const s: string): string;
function Trim(const S: string): string;
function IntToStr(Num : Integer) : String;
function ExtractFileName(const s: string): string;
function ChangeFileExt(const FileName, Extension: string): string;
//function NotFileExists(S:String):boolean;

implementation

function ChangeFileExt(const FileName, Extension: string): string;
var
  io,I: Integer;
  S: String;
begin
io := POS('\',FileName);
I := POS('.',FileName);
s := Copy(FileName,io+1,i-1);
    Result:= S+Extension;
end;

function NotFileExists(S:String):boolean;
begin
Result:=false;
//if S='' then begin MessageBox(0,Pchar('No a file name "'+s+'"'),EngineCodeName,0); result:=true; exit; end;
//if not FileExists(S) then begin MessageBox(0,Pchar('File not found "'+s+'"'),EngineCodeName,0); result:=true; exit; end;

end;

function IntToStr(Num : Integer) : String;
begin
  Str(Num, result);
end;

function AnsiUpperCase(const S: string): string;
var
  Len: Integer;
begin
  Len := Length(S);
  SetString(Result, PChar(S), Len);
  if Len > 0 then CharUpperBuff(Pointer(Result), Len);
end;

function FileExists(FileName: string): boolean;
var
 F: File;
begin
FileMode := 64;
AssignFile(F, FileName);
{$I-}
Reset(F);
{$I+}
Result:=IOResult=0;
if Result then
 CloseFile(F);
end;

Function SameText(A,B:String):Boolean;
begin
if AnsiUpperCase(a) = AnsiUpperCase(b) then result:=true else result:=false;
end;

function CompareMem(P1, P2: Pointer; Length: Integer): Boolean; assembler;
asm
        PUSH    ESI
        PUSH    EDI
        MOV     ESI,P1
        MOV     EDI,P2
        MOV     EDX,ECX
        XOR     EAX,EAX
        AND     EDX,3
        SAR     ECX,2
        JS      @@1     // Negative Length implies identity.
        REPE    CMPSD
        JNE     @@2
        MOV     ECX,EDX
        REPE    CMPSB
        JNE     @@2
@@1:    INC     EAX
@@2:    POP     EDI
        POP     ESI
end;

function LowerCase(const S: string): string;
var
  Ch: Char;
  L: Integer;
  Source, Dest: PChar;
begin
  L := Length(S);
  SetLength(Result, L);
  Source := Pointer(S);
  Dest := Pointer(Result);
  while L <> 0 do
  begin
    Ch := Source^;
    if (Ch >= 'A') and (Ch <= 'Z') then Inc(Ch, 32);
    Dest^ := Ch;
    Inc(Source);
    Inc(Dest);
    Dec(L);
  end;
end;

function StrToIntDef(const S: string; Default: Integer): Integer;
var
  E: Integer;
begin
  Val(S, Result, E);
  if E <> 0 then Result := Default;
end;

function FloatToStr(Value: Extended): string;
var
  Buffer: array[0..63] of Char;
begin
  SetString(Result, Buffer, Round(VAlue));
end;

function  StrToFloatDef(strValue : String; defValue : Single) : Single;
var
   i, divider, lLen : Integer;
   c : Char;
begin
   Result:=0;
   if strValue='' then Exit;
   divider:=MaxInt;
   strValue:=Trim(StrValue);
   lLen:=length(strValue);
  for i:=1 to lLen do begin
      c:=strValue[i];
      case c of
         '0'..'9' : Result:=(Result*10)+Integer(c)-Integer('0');
         ',', '.' : begin
            if (divider=MaxInt) then
               divider:=i
            else begin
               Result:=defValue;
               Exit;
            end;
         end;
         '-', '+' : if i>1 then begin
            Result:=defValue;
            Exit;
         end;
    else
         if (c<>' ') or (divider<>MaxInt) then begin
            Result:=defValue;
            Exit;
         end;
      end;
   end;
   divider:=lLen-divider;
   if divider>0 then Result:=Result*Exp(-divider*Ln(10));
   if (strValue[1]='-') then Result:=-Result;
end;

function StrPas(const Str: PChar): string;
begin
  Result := Str;
end;

function booltostr(B:Boolean):String;
begin
if b then result:='True' else result:='False';
end;

function TrimLeft(const S: string): string;
var
  I, L: Integer;
begin
  L := Length(S);
  I := 1;
  while (I <= L) and (S[I] <= ' ') do Inc(I);
  Result := Copy(S, I, Maxint);
end;

function ExtractFilePath(const s: string): string;
var
i :integer;
begin
//    setlength(s,length(s)-1);
    for i :=length(s)-1 downto 1 do
    if s[i]='\' then
    begin
    result := copy(s,1,i);
    exit;
    end;
end;

function ExtractFileName(const s: string): string;
var
i :integer;
begin
//    setlength(s,length(s)-1);
    for i :=length(s)-1 downto 1 do
    if s[i]='\' then
    begin
    result := copy(s,i,length(s)-i);
    exit;
    end;
end;

function Trim(const S: string): string;
var
  I, L: Integer;
begin
  L := Length(S);
  I := 1;
  while (I <= L) and (S[I] <= ' ') do Inc(I);
  if I > L then Result := '' else
  begin
    while S[L] <= ' ' do Dec(L);
    Result := Copy(S, I, L - I + 1);
  end;
end;

end.
