unit engine;
{$Warnings off}
{$Hints on}
(* ************************* *)
(* SVSD_VAL 3D Engine V 1.40 *)
(* ************************* *)
(* * ICQ  223725915        * *)
(* * Mail Valdim_05Mail.ru * *)
(* * Site Svsd.MirGames.Ru * *)
(* ************************* *)
interface

uses
  Windows, OpenGL,L_Math;

const
  TheEngine = 'engine.dll'; // x}X{x

	PS_FIRE     =$001;
  PS_EXPLODE  =$002;
  PS_SMOKE    =$003;

type
  //   SysUtils !!
  TByteArray = array [0..1023] of Byte;
  PByteArray = ^TByteArray;

  // --     Classes  MyClasses.pas !!!!
  TStream         = byte; //        !!

  TSprite         = Record
    ImageWidth,
    ImageHeight,
    FrameW,
    FrameH        : integer;   //     65535     512  ...
    FXCount,
    FYCount       : Integer;

    Draw2DSize    : TVector;
    Draw3DSize    : Single;
  end;

 (* !!!!    -          !!!! *)
   ICollide = Interface
    Function CubeVsPoint   (Box,Point :TVector; Size:Single):Boolean;                        stdcall;
    Function BoxVsPoint    (Box,BoxSize,Point :TVector):Boolean;                             stdcall;
    function AABBVsPoint   (Minx,Maxx,Pos : TVector): boolean;                               stdcall;
    function BoxVsBox      (Box1,Box2, Box1Size,Box2Size :TVector): boolean;                 stdcall;
    Function AABBVsAABB    (Minx1,Maxx1,Minx2,Maxx2:TVector): boolean;                       stdcall;
    function AABBVsSphere  (Minx,Maxx,Pos : TVector;R:Single): boolean;                      stdcall;
    function CubeVsLine    (BP,LBEGIN,LEND : TVector;BS :single): boolean;                   stdcall;
    function SphereVsPoint (Sphere ,Point : TVector; R: Single): boolean;                    stdcall;
    Function SphereVsSphere(Sphere1,Sphere2 : TVector; R1,R2 : Single) : boolean;            stdcall;
    function SphereVsLine  (Sphere ,LB,LE : TVector;R: Single): boolean;                     stdcall;
   end;

  IGLFX       = Interface
    Function  ADDParticleSystem        (POS:TVector;ParticleCount,UpdateTime,
                                        Mode,DrawSize:Cardinal):integer;                     stdcall;
    Procedure DrawParticleSystem;                                                            stdcall;
    Procedure DrawParticleSystemWithNum(Num:Integer);                                        stdcall;
                                                                                             stdcall;
    Procedure ChangePosParticleSystem  (Num:Integer;POS:TVector);                            stdcall;
    Procedure SetFrameTime             (F:Single);                                           stdcall;
    Procedure SetParticleSpeed         (Num:Integer;Speed,LiveSpeed:Single);                 stdcall;
    Function  GetParticlesCount        :Integer;                                             stdcall;
    Procedure SetParticlePos           (Num:Integer;POS:TVector);                            stdcall;
    Procedure SetParticleTime          (Num,Time:Integer;clear:boolean);                     stdcall;
    Procedure SetEnableParticle        (Num:Integer;enabled:boolean);                        stdcall;
    Procedure FreeParticles;                                                                 stdcall;
    Procedure LoadTextureFromFile      (FileName:String);                                    stdcall;
  end;

  IMediaPlayer = Interface
    procedure Load  (FileName:string);                                                       stdcall;
    procedure Close;                                                                         stdcall;
    procedure Play;                                                                          stdcall;
    procedure Stop;                                                                          stdcall;
    procedure Pause;                                                                         stdcall;
    procedure SetDisplayHandle(Value : Hwnd);                                                stdcall;
    procedure SetDisplayRect  (Value :TRect);                                                stdcall;
    function  GetLength   : Longint;                                                         stdcall;
    function  GetPosition : Longint;                                                         stdcall;
  end;

 IWater = Interface
   procedure InitWater (Size,DrawSize:integer;Texture:String);                               stdcall;
   procedure DrawWater                                                                       stdcall;
   procedure CreateRainDrop;                                                                 stdcall;
   procedure CreateObjectMove(POS:TVector;YADD:single);                                      stdcall;
   Procedure Update    (FrameTime:integer);                                                  stdcall;
   procedure SetWaterPos(Pos:TVector);                                                       stdcall;
   procedure SetWaterDetail(TexDetail:single);                                               stdcall;
 end;

 IAviTexture = Interface
   procedure Init(WND:HWND);                                                                 stdcall;
   procedure LoadAVI(filename : String);                                                     stdcall;
   procedure CloseAVI;                                                                       stdcall;
   Function  GetAVIFrame:cardinal;                                                           stdcall;
 end;

 IDXSound = Interface
   function  snd_Init             (WND:HWND): boolean;                                       stdcall;
   procedure snd_deInit;                                                                     stdcall;
   function  snd_Load             (const FileName: string): integer;                         stdcall;
   function  snd_LoadFromStream   (Stream:TStream): integer;                                 stdcall;
   function  snd_Free             (Sample_ID: integer): boolean;                             stdcall;
   procedure snd_BeginUpdate;                                                                stdcall;
   procedure snd_EndUpdate;                                                                  stdcall;
   function  snd_Play             (Sample_ID: integer; Loop: boolean; Pos: TVector): integer;stdcall;
   function  snd_Stop             (var Channel_ID: integer): boolean;                        stdcall;
   procedure snd_StopAll          (Sound_ID: integer);                                       stdcall;
   function  snd_SetVolume        (Channel_ID: integer; Volume: integer): boolean;           stdcall;
   function  snd_SetPos           (Channel_ID: integer; Pos: TVector): boolean;              stdcall;
   function  snd_SetFreq          (Channel_ID: integer; Freq: DWORD): boolean;               stdcall;
   procedure snd_SetVelocity      (Channel_ID: integer; Pos: TVector);                       stdcall;
   procedure snd_SetOrientation   (front, top: TVector);                                     stdcall;
   procedure snd_SetDopplerFactor (factor: single);                                          stdcall;
   procedure snd_SetRolloffFactor (factor: single);                                          stdcall;
   procedure snd_SetDistanceFactor(Dst   : single);                                          stdcall;
   procedure snd_SetGlobalPos     (Pos: TVector);                                            stdcall;
   procedure snd_SetGlobalVelocity(V: TVector);                                              stdcall;
   procedure snd_Update;                                                                     stdcall;
 end;

  IXMMusic = Interface
    function LoadFromFile(FileName: String): Boolean;                                        stdcall;
    function LoadFromRes(ResName, ResType: String): Boolean;                                 stdcall;
    function Free: ByteBool;                                                                 stdcall;
    function Play: ByteBool;                                                                 stdcall;
    function Stop: ByteBool;                                                                 stdcall;
    function GetOrder: Integer;                                                              stdcall;
    function GetRow: Integer;                                                                stdcall;
    function GetTime: Cardinal;                                                              stdcall;
  end;

  IDrawGL = Interface
    Procedure EnableBlend      (Tip:byte);                                                   stdcall;
    Procedure EnableAlpha      (Enabled:boolean;Ref:single);			                           stdcall;
    Procedure Draw2DSpr        (X,Y,W,H,Rotate:Single;Texture : Cardinal);                   stdcall;
    Procedure Draw2DSpr2       (X,Y,W,H,Rotate:Single;Texture : Cardinal);                   stdcall;
    Procedure Draw2DSpr3       (X,Y,W,H,Rotate:Single;Texture : Cardinal);                   stdcall;
    Procedure Draw2DFrame      (const x,y,W,H,Rotate:Single;const IW,IH,  FW,FH,  FXC,FYC,Frame:Integer;const Texture:Cardinal);   stdcall;
    Procedure DrawCube         (X,Y,W,H:Single);                                             stdcall;
    Procedure DrawFrameParticle(Position: TVector; Size: Single; const IW,IH,  FW,FH,  FXC,FYC,Frame:Integer; TEXTURE : cARDINAL); stdcall;
    Procedure DrawParticle     (Position: TVector; Size: Single; TEXTURE : CARDINAL);        stdcall;
    Procedure InitSkyBox       (FR,BK,LF,RT,UP,DN:String);                                   stdcall;
    Procedure DrawSkyBox       (W:Single);                                                   stdcall;
    Procedure FlareInit        (FlareDir,FlareName,ext:String;w,h: integer; Pos:Tvector);    stdcall;
    Procedure SetFlarePos      (pos:Tvector);                                                stdcall;
    Procedure ResizeFlare      (w,h: integer);                                               stdcall;
    Procedure DoFlare          (FrameTime:single);                                           stdcall;
  end;

  IModels     = interface
    function  ADDMD2        (Fn,Tn     : String) : integer;                                  stdcall;
    function  ADDM4Model    (Fn,TexDir : String) : integer;                                  stdcall;
    function  ADDSam        (Fn,Tn     : String) : integer;                                  stdcall;

    Procedure FreeModels(FreeMD2,Free4Model,FreeSam:boolean);                                stdcall;
    Procedure FreeAllModels;                                                                 stdcall;

    Procedure DrawMd2         (const ModelID :Integer;const POS,Ran:TVector;const Frame1,StartFrame,EndFrame:Single;const Scale:Single=1); stdcall;
    Procedure DrawSam         (const ModelID :Integer;const POS,Ran:TVector;const Frame1,StartFrame,EndFrame:Single;const Scale:Single=1); stdcall;
    Procedure DrawModel4      (const ModelID :Integer;const POS,Ran:TVector);                stdcall;
    Procedure DrawModel4Object(const ModelID,ObjectNum :Integer;const POS:TVector);          stdcall;

    Function  Model4Collision (const ModelID :Integer;const ModelPos:TVector; var POS:TVector;R:Single):boolean; stdcall;
    Function  Model4OnGround  (const ModelID :Integer;const ModelPos,POS:TVector;R:Single):Boolean; stdcall;
    Function  LineCollision   (const ModelID :Integer;const ModelPos:TVector; const BP,EP:TVector):boolean; stdcall;
    Function  LineCollision2  (const ModelID :Integer;const ModelPos:TVector; const BP,EP:TVector):TVector; stdcall;
  end;

 ILandMap = interface
    procedure MapFree;  stdcall;
    function  LoadFromFile         (const HeightName, DetailName, MapTexName: string): boolean; stdcall;
    function  LoadFromLMFile       (const HeightName, DetailName, MapTexName: string): boolean; stdcall;
    function  CollisionWNormal     (var   Pos, Normal: TVector): integer;                       stdcall;
    function  Collision            (var   Pos: TVector;Yadd:Single): integer;                   stdcall;
    function  CollisionNoMapLimints(var   Pos: TVector;Yadd:Single): integer;                   stdcall;
    function  CollisionND          (var   Pos: TVector;Yadd:Single): integer;                   stdcall;
    function  OnGround             (const Pos: TVector;Yadd:Single):boolean;                    stdcall;
    function  LineCollision        (const BP,EP: TVector): TVector;                             stdcall;
    function  LineBCollision       (const BP,EP: TVector): Boolean;                             stdcall;
    function  GetColorOnGround     (const Pos: TVector): TVector;                               stdcall;
    procedure MapSetSize           (Scale,YScale,TexDetail:Single);                             stdcall;
    procedure Setings              (UseFrust,UseDetail:boolean);                                stdcall;
    procedure Render;                                                                           stdcall;
    procedure RenderWOutTex;                                                                    stdcall;
 end;

  ILog = interface
    function  Create(FileName: String): Boolean;                                                stdcall;
    procedure Write(Text: String);                                                              stdcall;
    function  Msg(Caption, Text: String; ID: Cardinal): Integer;                                stdcall;
    procedure Free;                                                                             stdcall;
  end;

(** ************************************************************************* *)
//Engine.dpr
procedure InitLog     (out Log   : ILog; LogFile: String); stdcall; external TheEngine;
procedure InitLandMap (out Map   : ILandMap);              stdcall; external TheEngine;
procedure InitModels  (out Models: IModels);               stdcall; external TheEngine;

procedure InitDrawGL  (out DrawGL : IDrawGL );             stdcall; external TheEngine;
procedure InitDxSound (out DXSound: IDXSound);             stdcall; external TheEngine;
procedure InitXMMusic (out XMMusic: IXMMusic);             stdcall; external TheEngine;
procedure InitAviTexture(out AviTexture: IAviTexture);     stdcall; external TheEngine;
procedure InitWater   (out Water: IWater);                 stdcall; external TheEngine;
procedure InitMediaPlayer(out MediaPlayer: IMediaPlayer);  stdcall; external TheEngine;
procedure InitGLFX    (out GLFX: IGLFX);                   stdcall; external TheEngine;
procedure InitCollide (out Collide: ICollide);             stdcall; external TheEngine;
procedure AboutMe;                                                                             external TheEngine;

//log.pas
Procedure LogingEngine(FileName:String);                                                       external TheEngine;
Procedure LogWrite(S:String;Tip:byte);(* 0 Msg , 1 Ok , 2 Error , 3 Info *)                    external TheEngine;
//GL.pas
Function  CreateDevice(Handle: HWND; Width,Height: integer):HDC;                               external TheEngine;
procedure CloseDevice(Handle: HWND);                                                           external TheEngine;
procedure SetFov(theFov:single=45;thezmin:single=1; thezmax:single=10000;
                                  thezmin2d:single=0.01;thezmax2d:single=10);                  external TheEngine;
Procedure SetProjection(W, H: integer; Ortho: boolean);                                        external TheEngine;
procedure ResizeGLWnd(Width,Height:Integer);                                                   external TheEngine;
procedure GL_Present;                                                                          external TheEngine;
//Textures.pas
Procedure TextureMode(UseMipMap,UseANISOTROPY :boolean; NumANISOTROPY :integer);               external TheEngine;
function  LoadTexture  (Filename: String; var Texture : cardinal;Alpha:boolean=false;Color:integer=0;Quality:integer=100) : Boolean; external TheEngine;
function  LoadTextureEx(Filename: String; var W,H,BPP:Integer; var pData : PByteArray) : Boolean;                                  external TheEngine;
//Vsync.pas
Procedure WaitVSync(b:boolean);                                                                external TheEngine;
//ScrMode.pas
function  VidMode(FullScreen,Border: Boolean; W, H, BPP, Freq: Integer): Boolean;              external TheEngine;
function  VidModeHWND(Wnd:HWND;FullScreen,Border: Boolean; W, H, BPP, Freq: Integer): Boolean; external TheEngine;
//Fnt.pas
procedure BuildFont(FontName:String;W,H:integer);                                              external TheEngine;
procedure KillFont;                                                                            external TheEngine;
procedure DrawTxt  (X,Y : integer; text : String);                                             external TheEngine;
//Frust.pas
Procedure CalculateFrustum;                                                                    external TheEngine;
function  PointInFrustum ( V:TVector) : BOOLEAN;                                               external TheEngine;
function  SphereInFrustum( V:TVector; radius : single) : boolean;                              external TheEngine;
function  CubeInFrustum  ( V:TVector; size : single) : boolean;                                external TheEngine;
function  BoxInFrustum   ( Min,Max:TVector) : boolean;                                         external TheEngine;
function  GetDrawObjectsCount:Cardinal;                                                        external TheEngine;

// Sprite.pas
Procedure InitSprite(Var Sprite:TSprite; Const ImageSize,FrameSize,FrameCount,DrawSize:Tvector;DrawSize3d:single=5); external TheEngine;
Procedure Draw2DSprite(Pos : TVector; Ran:Single; Frame:Integer; Sprite:TSprite;Texture:Cardinal);                   external TheEngine;
Procedure Draw3DSprite(Pos : TVector; Frame:Integer; Sprite:TSprite; Texture:Cardinal);                              external TheEngine;

(** ************************************************************************* *)
procedure glBindTexture       (Target: GLenum; texture: GLuint); stdcall; external opengl32;

implementation

end.
